Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION > Class Template Reference

`#include <mqv.h>`

Inheritance diagram for MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >:

List of all members.

## Detailed Description

### template<class GROUP_PARAMETERS, class COFACTOR_OPTION = typename GROUP_PARAMETERS::DefaultCofactorOption>
class MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >

Definition at line 13 of file mqv.h.

## Public Types
typedef GROUP_PARAMETERS | GroupParameters
typedef GroupParameters::Element | Element
typedef MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION > | Domain
## Public Member Functions
| MQV_Domain (const GroupParameters &params)
| MQV_Domain (BufferedTransformation &bt)
template<class T1, class T2> | MQV_Domain (T1 v1, T2 v2)
template<class T1, class T2, class T3> | MQV_Domain (T1 v1, T2 v2, T2 v3)
template<class T1, class T2, class T3, class T4> | MQV_Domain (T1 v1, T2 v2, T3 v3, T4 v4)
const GroupParameters & | GetGroupParameters () const
GroupParameters & | AccessGroupParameters ()
CryptoParameters & | AccessCryptoParameters ()
unsigned int | AgreedValueLength () const
| return length of agreed value produced
unsigned int | StaticPrivateKeyLength () const
| return length of static private keys in this domain
unsigned int | StaticPublicKeyLength () const
| return length of static public keys in this domain
void | GenerateStaticPrivateKey (RandomNumberGenerator &rng, byte *privateKey) const
| generate static private key
void | GenerateStaticPublicKey (RandomNumberGenerator &rng, const byte *privateKey, byte *publicKey) const
| generate static public key
unsigned int | EphemeralPrivateKeyLength () const
| return length of ephemeral private keys in this domain
unsigned int | EphemeralPublicKeyLength () const
| return length of ephemeral public keys in this domain
void | GenerateEphemeralPrivateKey (RandomNumberGenerator &rng, byte *privateKey) const
| generate ephemeral private key
void | GenerateEphemeralPublicKey (RandomNumberGenerator &rng, const byte *privateKey, byte *publicKey) const
| generate ephemeral public key
bool | Agree (byte *agreedValue, const byte *staticPrivateKey, const byte *ephemeralPrivateKey, const byte *staticOtherPublicKey, const byte *ephemeralOtherPublicKey, bool validateStaticOtherPublicKey=true) const
| derive agreed value from your private keys and couterparty's public keys, return false in case of failure
virtual void | GenerateStaticKeyPair (RandomNumberGenerator &rng, byte *privateKey, byte *publicKey) const
| generate private/public key pair
virtual void | GenerateEphemeralKeyPair (RandomNumberGenerator &rng, byte *privateKey, byte *publicKey) const
| generate private/public key pair
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
virtual const CryptoParameters & | GetCryptoParameters () const
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Member Function Documentation

template<class GROUP_PARAMETERS, class COFACTOR_OPTION = typename GROUP_PARAMETERS::DefaultCofactorOption>
void MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::GenerateStaticPrivateKey | ( | RandomNumberGenerator & | rng,
|  | byte * | privateKey
| ) | const`[inline, virtual]`

| generate static private key Precondition: size of privateKey == PrivateStaticKeyLength() Implements AuthenticatedKeyAgreementDomain. Definition at line 49 of file mqv.h. References Integer::One(), and MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::StaticPrivateKeyLength().

template<class GROUP_PARAMETERS, class COFACTOR_OPTION = typename GROUP_PARAMETERS::DefaultCofactorOption>
void MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::GenerateStaticPublicKey | ( | RandomNumberGenerator & | rng,
|  | const byte * | privateKey,
|  | byte * | publicKey
| ) | const`[inline, virtual]`

| generate static public key Precondition: size of publicKey == PublicStaticKeyLength() Implements AuthenticatedKeyAgreementDomain. Definition at line 55 of file mqv.h. References DL_GroupParameters< T >::EncodeElement(), DL_GroupParameters< T >::ExponentiateBase(), and MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::StaticPrivateKeyLength().

template<class GROUP_PARAMETERS, class COFACTOR_OPTION = typename GROUP_PARAMETERS::DefaultCofactorOption>
void MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::GenerateEphemeralPrivateKey | ( | RandomNumberGenerator & | rng,
|  | byte * | privateKey
| ) | const`[inline, virtual]`

| generate ephemeral private key Precondition: size of privateKey == PrivateEphemeralKeyLength() Implements AuthenticatedKeyAgreementDomain. Definition at line 66 of file mqv.h. References DL_GroupParameters< T >::EncodeElement(), DL_GroupParameters< T >::ExponentiateBase(), DL_GroupParameters< T >::GetMaxExponent(), Integer::One(), and MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::StaticPrivateKeyLength().

template<class GROUP_PARAMETERS, class COFACTOR_OPTION = typename GROUP_PARAMETERS::DefaultCofactorOption>
void MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::GenerateEphemeralPublicKey | ( | RandomNumberGenerator & | rng,
|  | const byte * | privateKey,
|  | byte * | publicKey
| ) | const`[inline, virtual]`

| generate ephemeral public key Precondition: size of publicKey == PublicEphemeralKeyLength() Implements AuthenticatedKeyAgreementDomain. Definition at line 75 of file mqv.h. References MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::EphemeralPublicKeyLength(), and MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::StaticPrivateKeyLength().

template<class GROUP_PARAMETERS, class COFACTOR_OPTION = typename GROUP_PARAMETERS::DefaultCofactorOption>
bool MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::Agree | ( | byte * | agreedValue,
|  | const byte * | staticPrivateKey,
|  | const byte * | ephemeralPrivateKey,
|  | const byte * | staticOtherPublicKey,
|  | const byte * | ephemeralOtherPublicKey,
|  | bool | validateStaticOtherPublicKey = true
| ) | const`[inline, virtual]`

| derive agreed value from your private keys and couterparty's public keys, return false in case of failure Note: The ephemeral public key will always be validated. If you have previously validated the static public key, use validateStaticOtherPublicKey=false to save time. Precondition: size of agreedValue == AgreedValueLength() length of staticPrivateKey == StaticPrivateKeyLength() length of ephemeralPrivateKey == EphemeralPrivateKeyLength() length of staticOtherPublicKey == StaticPublicKeyLength() length of ephemeralOtherPublicKey == EphemeralPublicKeyLength() Implements AuthenticatedKeyAgreementDomain. Definition at line 80 of file mqv.h. References Integer::BitCount(), DL_GroupParameters< T >::ConvertElementToInteger(), DL_GroupParameters< T >::DecodeElement(), DL_GroupParameters< T >::EncodeElement(), DL_GroupParameters< T >::ExponentiateElement(), DL_GroupParameters< T >::GetCofactor(), DL_GroupParameters< T >::GetSubgroupOrder(), DL_GroupParameters< T >::IsIdentity(), Integer::Power2(), DL_GroupParameters< T >::SimultaneousExponentiate(), and MQV_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::StaticPrivateKeyLength().

void AuthenticatedKeyAgreementDomain::GenerateStaticKeyPair | ( | RandomNumberGenerator & | rng,
|  | byte * | privateKey,
|  | byte * | publicKey
| ) | const`[virtual, inherited]`

| generate private/public key pair Note: equivalent to calling GenerateStaticPrivateKey() and then GenerateStaticPublicKey() Reimplemented in DH2. Definition at line 651 of file cryptlib.cpp. References AuthenticatedKeyAgreementDomain::GenerateStaticPrivateKey(), and AuthenticatedKeyAgreementDomain::GenerateStaticPublicKey().

void AuthenticatedKeyAgreementDomain::GenerateEphemeralKeyPair | ( | RandomNumberGenerator & | rng,
|  | byte * | privateKey,
|  | byte * | publicKey
| ) | const`[virtual, inherited]`

| generate private/public key pair Note: equivalent to calling GenerateEphemeralPrivateKey() and then GenerateEphemeralPublicKey() Reimplemented in DH2. Definition at line 657 of file cryptlib.cpp. References AuthenticatedKeyAgreementDomain::GenerateEphemeralPrivateKey(), and AuthenticatedKeyAgreementDomain::GenerateEphemeralPublicKey().

The documentation for this class was generated from the following file:

- mqv.h